module dfc.examples.bitmapview.basecontrols;

import std.string;

import win32.api;
import dfc.bitmap;
import dfc.core;

import win32.commdlg;

class FileLoadDialog {
	static bit openFile( HWND hwnd, out char[] name ) {
		OPENFILENAMEA info;
		char[512] filename_buf;
		filename_buf[0] = '\0';
		info.lStructSize = OPENFILENAME.sizeof;
		info.hwndOwner = hwnd;
    	info.hInstance = null;
		info.lpstrFilter = null;
		info.lpstrCustomFilter = null;
    	info.nMaxCustFilter = 0;
		info.nFilterIndex = 0;
		info.lpstrFile = filename_buf;
		info.nMaxFile = 511;
		info.lpstrFileTitle = null;
		info.nMaxFileTitle = 0;
		info.lpstrInitialDir = null;
		info.lpstrTitle = null;
		info.Flags = OFN_LONGNAMES|OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST;

		info.nFileOffset =0;
		info.nFileExtension =0;
		info.lpstrDefExt = null;
		info.lCustData = 0;
		info.lpfnHook = null;
		info.lpTemplateName = null;

		if ( GetOpenFileNameA( &info ) ) {
			name = std.string.toString( info.lpstrFile );
			name = name.dup; // very very needed
			return true;
		}
		return false;
	}
}

class FileSaveDialog {
	static bit openFile( HWND hwnd, out char[] name ) {
		OPENFILENAMEA info;
		char[512] filename_buf;
		filename_buf[0] = '\0';
		info.lStructSize = OPENFILENAME.sizeof;
		info.hwndOwner = hwnd;
    	info.hInstance = null;
		info.lpstrFilter = null;
		info.lpstrCustomFilter = null;
    	info.nMaxCustFilter = 0;
		info.nFilterIndex = 0;
		info.lpstrFile = filename_buf;
		info.nMaxFile = 511;
		info.lpstrFileTitle = null;
		info.nMaxFileTitle = 0;
		info.lpstrInitialDir = null;
		info.lpstrTitle = null;
		info.Flags = OFN_LONGNAMES|OFN_EXPLORER|OFN_CREATEPROMPT|OFN_NOREADONLYRETURN|OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY;

		info.nFileOffset =0;
		info.nFileExtension =0;
		info.lpstrDefExt = null;
		info.lCustData = 0;
		info.lpfnHook = null;
		info.lpTemplateName = null;

		if ( GetSaveFileNameA( &info ) ) {
			name = std.string.toString( info.lpstrFile );
			name = name.dup; //!!! very very needed
			return true;
		}
		return false;
	}
}


class UserApp : DApp {
	this() { super(); }
protected:
	//                               0xBBGGRR
	const DWORD HILIGHT_ONE_COLOR  = 0xD3D3D3;
	const DWORD MIDLIGHT_ONE_COLOR = 0xA3A3A3;
	const DWORD LOLIGHT_ONE_COLOR  = 0x636363;

	const DWORD HILIGHT_TWO_COLOR  = 0xD333C3;
	const DWORD MIDLIGHT_TWO_COLOR = 0xA32393;
	const DWORD LOLIGHT_TWO_COLOR  = 0x631343;

	const DWORD HILIGHT_THREE_COLOR  = 0x33D333;
	const DWORD MIDLIGHT_THREE_COLOR = 0x23A323;
	const DWORD LOLIGHT_THREE_COLOR  = 0x136313;

	const DWORD ERROR_PEN_COLOR  = 0x4040FF;
	const DWORD FOCUS_PEN_COLOR  = 0xFF6000;

	static HFONT defaultFont;
	static HBRUSH hilightOneBrush;
	static HBRUSH midlightOneBrush;
	static HBRUSH lolightOneBrush;

	static HPEN hilightOnePen;
	static HPEN midlightOnePen;
	static HPEN lolightOnePen;

	static HBRUSH hilightTwoBrush;
	static HBRUSH midlightTwoBrush;
	static HBRUSH lolightTwoBrush;

	static HPEN hilightTwoPen;
	static HPEN midlightTwoPen;
	static HPEN lolightTwoPen;

	static HBRUSH hilightThreeBrush;
	static HBRUSH midlightThreeBrush;
	static HBRUSH lolightThreeBrush;

	static HPEN hilightThreePen;
	static HPEN midlightThreePen;
	static HPEN lolightThreePen;

	static HPEN errorPen;
	static HPEN focusPen;

	static ~this() {
		if ( hilightOneBrush ) { DeleteObject( hilightOneBrush ); }
		if ( midlightOneBrush ) { DeleteObject( midlightOneBrush ); }
		if ( lolightOneBrush ) { DeleteObject( lolightOneBrush ); }
		if ( hilightOnePen ) { DeleteObject( hilightOnePen ); }
		if ( midlightOnePen ) { DeleteObject( midlightOnePen ); }
		if ( lolightOnePen ) { DeleteObject( lolightOnePen ); }

		if ( hilightTwoBrush ) { DeleteObject( hilightTwoBrush ); }
		if ( midlightTwoBrush ) { DeleteObject( midlightTwoBrush ); }
		if ( lolightTwoBrush ) { DeleteObject( lolightTwoBrush ); }
		if ( hilightTwoPen ) { DeleteObject( hilightTwoPen ); }
		if ( midlightTwoPen ) { DeleteObject( midlightTwoPen ); }
		if ( lolightTwoPen ) { DeleteObject( lolightTwoPen ); }

		if ( hilightThreeBrush ) { DeleteObject( hilightThreeBrush ); }
		if ( midlightThreeBrush ) { DeleteObject( midlightThreeBrush ); }
		if ( lolightThreeBrush ) { DeleteObject( lolightThreeBrush ); }
		if ( hilightThreePen ) { DeleteObject( hilightThreePen ); }
		if ( midlightThreePen ) { DeleteObject( midlightThreePen ); }
		if ( lolightThreePen ) { DeleteObject( lolightThreePen ); }
	}

	static HFONT createDefaultFont() {
		return (defaultFont=CreateFontA(
								-11, 0, 0, 0, FW_NORMAL,
								FALSE, FALSE,
								FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
								DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
								"tahoma\0" ) );
	}

	static HBRUSH createHilightOneBrush() {
		return (hilightOneBrush = CreateSolidBrush( HILIGHT_ONE_COLOR ));
	}
	static HBRUSH createMidlightOneBrush() {
		return (midlightOneBrush = CreateSolidBrush( MIDLIGHT_ONE_COLOR ));
	}
	static HBRUSH createLolightOneBrush() {
		return (lolightOneBrush = CreateSolidBrush( LOLIGHT_ONE_COLOR ));
	}
	static HPEN createHilightOnePen() {
		return (hilightOnePen = CreatePen( PS_SOLID, 0, HILIGHT_ONE_COLOR ));
	}
	static HPEN createMidlightOnePen() {
		return (midlightOnePen = CreatePen( PS_SOLID, 0, MIDLIGHT_ONE_COLOR ));
	}
	static HPEN createLolightOnePen() {
		return (lolightOnePen = CreatePen( PS_SOLID, 0, LOLIGHT_ONE_COLOR ));
	}

	static HBRUSH createHilightTwoBrush() {
		return (hilightTwoBrush = CreateSolidBrush( HILIGHT_TWO_COLOR ));
	}
	static HBRUSH createMidlightTwoBrush() {
		return (midlightTwoBrush = CreateSolidBrush( MIDLIGHT_TWO_COLOR ));
	}
	static HBRUSH createLolightTwoBrush() {
		return (lolightTwoBrush = CreateSolidBrush( LOLIGHT_TWO_COLOR ));
	}
	static HPEN createHilightTwoPen() {
		return (hilightTwoPen = CreatePen( PS_SOLID, 0, HILIGHT_TWO_COLOR ));
	}
	static HPEN createMidlightTwoPen() {
		return (midlightTwoPen = CreatePen( PS_SOLID, 0, MIDLIGHT_TWO_COLOR ));
	}
	static HPEN createLolightTwoPen() {
		return (lolightTwoPen = CreatePen( PS_SOLID, 0, LOLIGHT_TWO_COLOR ));
	}

	static HBRUSH createHilightThreeBrush() {
		return (hilightThreeBrush = CreateSolidBrush( HILIGHT_THREE_COLOR ));
	}
	static HBRUSH createMidlightThreeBrush() {
		return (midlightThreeBrush = CreateSolidBrush( MIDLIGHT_THREE_COLOR ));
	}
	static HBRUSH createLolightThreeBrush() {
		return (lolightThreeBrush = CreateSolidBrush( LOLIGHT_THREE_COLOR ));
	}
	static HPEN createHilightThreePen() {
		return (hilightThreePen = CreatePen( PS_SOLID, 0, HILIGHT_THREE_COLOR ));
	}
	static HPEN createMidlightThreePen() {
		return (midlightThreePen = CreatePen( PS_SOLID, 0, MIDLIGHT_THREE_COLOR ));
	}
	static HPEN createLolightThreePen() {
		return (lolightThreePen = CreatePen( PS_SOLID, 0, LOLIGHT_THREE_COLOR ));
	}

	static HPEN createErrorPen() {
		return (errorPen = CreatePen( PS_SOLID, 0, ERROR_PEN_COLOR ));
	}
	static HPEN createFocusPen() {
		return (focusPen = CreatePen( PS_SOLID, 0, FOCUS_PEN_COLOR ));
	}

public:
	HFONT getDefaultFont() {
		return defaultFont?defaultFont:createDefaultFont();
	}
	HBRUSH getHilightOneBrush() {
		return hilightOneBrush?hilightOneBrush:createHilightOneBrush();
	}
	HBRUSH getMidlightOneBrush() {
		return midlightOneBrush?midlightOneBrush:createMidlightOneBrush();
	}
	HBRUSH getLolightOneBrush() {
		return lolightOneBrush?lolightOneBrush:createLolightOneBrush();
	}
	HPEN getHilightOnePen() {
		return hilightOnePen?hilightOnePen:createHilightOnePen();
	}
	HPEN getMidlightOnePen() {
		return midlightOnePen?midlightOnePen:createMidlightOnePen();
	}
	HPEN getLolightOnePen() {
		return lolightOnePen?lolightOnePen:createLolightOnePen();
	}

	HBRUSH getHilightTwoBrush() {
		return hilightTwoBrush?hilightTwoBrush:createHilightTwoBrush();
	}
	HBRUSH getMidlightTwoBrush() {
		return midlightTwoBrush?midlightTwoBrush:createMidlightTwoBrush();
	}
	HBRUSH getLolightTwoBrush() {
		return lolightTwoBrush?lolightTwoBrush:createLolightTwoBrush();
	}
	HPEN getHilightTwoPen() {
		return hilightTwoPen?hilightTwoPen:createHilightTwoPen();
	}
	HPEN getMidlightTwoPen() {
		return midlightTwoPen?midlightTwoPen:createMidlightTwoPen();
	}
	HPEN getLolightTwoPen() {
		return lolightTwoPen?lolightTwoPen:createLolightTwoPen();
	}

	HBRUSH getHilightThreeBrush() {
		return hilightThreeBrush?hilightThreeBrush:createHilightThreeBrush();
	}
	HBRUSH getMidlightThreeBrush() {
		return midlightThreeBrush?midlightThreeBrush:createMidlightThreeBrush();
	}
	HBRUSH getLolightThreeBrush() {
		return lolightThreeBrush?lolightThreeBrush:createLolightThreeBrush();
	}
	HPEN getHilightThreePen() {
		return hilightThreePen?hilightThreePen:createHilightThreePen();
	}
	HPEN getMidlightThreePen() {
		return midlightThreePen?midlightThreePen:createMidlightThreePen();
	}
	HPEN getLolightThreePen() {
		return lolightThreePen?lolightThreePen:createLolightThreePen();
	}

	HPEN getErrorPen() {
		return errorPen?errorPen:createErrorPen();
	}
	HPEN getFocusPen() {
		return focusPen?focusPen:createFocusPen();
	}
}

template Control( Application : UserApp ) {
/*	class AppInnerWnd : DWnd {
		protected Application app;
		private this( Application app, bit fake ) {
			// no call to super
		}
		private new( uint size ) {
			return gc.malloc( size );
		}
		public new( uint size, Application app0 ) {
			printf( "new AppInnerWnd(%p)\n", app0 );
			return new AppInnerWnd( app0, false );
		}
		public this( DWnd parent ) {
			printf( "new this(app:%p this:%p parent:%p)\n", app, this, parent );
			create( WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, parent );
		}
		public this() {
			printf( "new this(app:%p this:%p)\n", app, this );
			this( app );
		}
	}*/

	class AppWnd : DWnd {
		alias void delegate() CreateDelegate;
		alias void delegate(DWnd) ChildCreateDelegate;
		Application app;
		this( Application parent ) {
			super();
			create( WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, app = parent );
		}

		this( Application parent, CreateDelegate cf ) {
			super();
			app = parent;
			cf();
		}

		this( Application parent, DWnd visual, ChildCreateDelegate cf ) {
			super();
			app = parent;
			cf( visual );
		}

		protected this( Application parent, char[] clazz ) {
			super( clazz );
			create( WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, app = parent );
		}

		protected this( Application app0, DWnd parent ) {
			super();
			app = app0;
			create( WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, parent );
		}

		protected this( Application app0, DWnd parent, char[] clazz ) {
			super( clazz );
			app = app0;
			create( WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, parent );
		}
		protected this( Application app0, DWnd parent, char[] clazz, int id ) {
			super( clazz );
			app = app0;
			create( WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, parent, cast(HMENU)id );
		}

		protected this( bit fake ) {
			super();
		}

		static void deflateRect( inout RECT r, int dx, int dy ) {
			r.left += dx; r.right  -= dx;
			r.top  += dy; r.bottom -= dy;
		}
		static void moveRect( inout RECT r, int dx, int dy ) {
			r.left += dx; r.right  += dx;
			r.top  += dy; r.bottom += dy;
		}
		static void adjustRect( inout RECT r, int dx1, int dy1,int dx2, int dy2 ) {
			r.left += dx1; r.right  += dx2;
			r.top  += dy1; r.bottom += dy2;
		}

		static void setDeflatedRect( out RECT r, inout RECT src, int dx, int dy ) {
			r.left   = src.left   + dx;
			r.right  = src.right  - dx;
			r.top    = src.top    + dy;
			r.bottom = src.bottom - dy;
		}

		static bit within( inout RECT r, int x, int y ) {
			/* unsigned comparisons => only one jump */
			if ( cast(DWORD)(x-r.left) < cast(DWORD)(r.right-r.left) ) {
				return cast(DWORD)(y-r.top) < cast(DWORD)(r.bottom-r.top);
			}
			return false;
		}

		static void drawTricolBox( HDC dc, inout RECT rect, HPEN upper, HPEN middle, HPEN lower, HBRUSH fill ) {
			HPEN oldPen = cast(HPEN)SelectObject( dc, upper );
			if ( fill ) {
				RECT r;
				r.left = rect.left+1; r.right  = rect.right-1;
				r.top  = rect.top+1;  r.bottom = rect.bottom-1;
				FillRect( dc, &r, fill );
			}
			MoveToEx( dc, rect.left, rect.bottom-1, null );
			LineTo(   dc, rect.left, rect.top );
			LineTo(   dc, rect.right-1, rect.top );
			SelectObject( dc, middle );
			LineTo(   dc, rect.right-1, rect.top+1 );
			SelectObject( dc, lower );
			LineTo(   dc, rect.right-1, rect.bottom-1 );
			LineTo(   dc, rect.left, rect.bottom-1 );
			SelectObject( dc, middle );
			LineTo(   dc, rect.left-1, rect.bottom-1 );
			SelectObject( dc, oldPen );
		}

		static void drawString( HDC dc, HFONT ft, int x, int y, COLORREF col, wchar[] str )
		{
			COLORREF oldCol;
			HGDIOBJ oldFont;
			oldCol = SetTextColor( dc, col );
			oldFont = SelectObject( dc, ft );
			int oldMode = SetBkMode( dc, TRANSPARENT );
			TextOutW( dc, x, y, cast(wchar*)str, str.length );
			SetBkMode( dc, oldMode );
			SetTextColor( dc, oldCol );
			SelectObject( dc, oldFont );
		}
		static void drawStringCF( HDC dc, int x, int y, COLORREF col, wchar[] str, int len )
		{
			COLORREF oldCol;
			oldCol = SetTextColor( dc, col );
			int oldMode = SetBkMode( dc, TRANSPARENT );
			TextOutW( dc, x, y, cast(wchar*)str, len );
			SetBkMode( dc, oldMode );
			SetTextColor( dc, oldCol );
		}

		static void drawString( HDC dc, HFONT ft, int x, int y, COLORREF col, wchar[] str, int len )
		{
			COLORREF oldCol;
			HGDIOBJ oldFont;
			oldCol = SetTextColor( dc, col );
			oldFont = SelectObject( dc, ft );
			int oldMode = SetBkMode( dc, TRANSPARENT );
			TextOutW( dc, x, y, cast(wchar*)str, len );
			SetBkMode( dc, oldMode );
			SetTextColor( dc, oldCol );
			SelectObject( dc, oldFont );
		}

		public void drawText( HDC dc, int x, int y, wchar[] str )
		{
			drawString( dc, app.getDefaultFont(), x, y, 0, str );
		}
	}

	public class AppSubclassedWnd : AppWnd {
	protected:
		WNDPROC subClassWindProc;
	public:
		this( Application parent, char[] classname ) {
			super( parent, classname );
		}

		protected this( Application app0, DWnd parent, char[] classname ) {
			super( app0, parent, classname );
		}

		protected this( Application app0, DWnd parent, char[] classname, int id ) {
			super( app0, parent, classname, id );
		}

		protected this( bit fake ) { super( fake ); }

		void postCreateWindow()
		{
			subClassWindProc = DFC.subclass( hwnd );
		}

		LRESULT unhandledMsg( HWND msghwnd, UINT msg, WPARAM wparam, LPARAM lparam )
		{
			return CallWindowProcA( subClassWindProc, msghwnd, msg, wparam, lparam );
		}
	}
}

template Control( Application : UserApp, Parent : DWnd ) {
	Control!( Application ) AppCtrl;
	class ChildWnd : AppCtrl.AppWnd {
		Parent parent;
		alias AppCtrl.AppWnd.ChildCreateDelegate CreateFunc;

		this( Application app0, Parent p, DWnd visual, CreateFunc cf ) {
			parent = p;
			super( app0, visual, cf );
			addPaintHandler( WM_PAINT, &onPaint );
		}

		this( Application app0,  Parent p, CreateFunc cf ) {
			this( app0, p, p, cf );
		}

		this( Application app0, Parent p, DWnd visual ) {
			this( app0, p, visual, &doCreate );
		}

		this( Application app0, Parent p ) {
			this( app0, p, p, &doCreate );
		}

		void doCreate( DWnd visual ) {
			create( WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, visual );
		}

		LRESULT onPaint( HDC dc ) {
			RECT rect;
			getClientRect( rect );
			FillRect( dc, &rect, app.getMidlightOneBrush() );
			return cast(LRESULT)0;
		}
	}
}

