module dfc.examples.bitmapview.main;

//import cmdline.options;
import std.stream;
import win32.api;
import dfc.core;
import dfc.button;
import dfc.tree;
import dfc.edit;
import winex.winmm;

import std.c.stdio;
import std.asserterror;

import dfc.examples.bitmapview.bitview;

int
beginApplication()
{
	BitViewApp app;

	DFC.beginApplication();

	app = new BitViewApp();

	app.showWindow( true );
	InvalidateRect( app.getHwnd(), null, true );
	DFC.msgLoop();

	return 0;
}

extern (C) void gc_init();
extern (C) void gc_term();
extern (C) void _minit();
extern (C) void _moduleCtor();
extern (C) void _moduleUnitTests();

extern (Windows)
int WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR lpCmdLine,
	int nCmdShow
)
{
	int result;
	try
	{
		gc_init();			// initialize garbage collector
		_minit();			// initialize module constructor table
		_moduleCtor();		// call module constructors
		version( UNITTEST )
		{
			_moduleUnitTests();	// run unit tests (optional)
		}
		result = beginApplication();	// insert user code here
	} catch ( Exception e ) {
		printf("catch Exception %.*s\n", e.toString() );
		e.print();
		MessageBoxA( null, cast(char *)e.toString(), "Exception", MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL );
		return 20;
	} catch ( Error er ) {
		printf("catch Error %.*s\n", er.toString() );
		er.print();
		MessageBoxA( null, cast(char *)er.toString(), "Error", MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL );
		return 21;
	} catch ( AssertError aer ) {
		printf("catch AssertError %.*s\n", aer.toString() );
		aer.print();
		MessageBoxA( null, cast(char *)aer.toString(), "AssertError", MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL );
		return 22;
	} catch ( Object o ) {
		printf("*---- ARRGH !!!!!!!!!!!!!!!\n");
		o.print();
		char * msg = cast(char *)o.toString();
		MessageBoxA( null, msg?msg:"<undef>", "Error", MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL );
		result = 0;		// failed
	}

	gc_term();	// run finalizers; terminate garbage collector
	return result;
}

